// -----------------------------------------------------------------------------
//  Copyright (c) 2000     Southeastern Universities Research Association,
//                         Thomas Jefferson National Accelerator Facility
// 
//  This software was developed under a United States Government license
//  described in the NOTICE file included as part of this distribution.
// -----------------------------------------------------------------------------
// 
//  Project Overview: 
// 	This source code was developed as a component of the UnderLord 
// 	Scheduler for the Parallel Batch System - A joint, wide-area computing
// 	initiative at Jefferson Lab and MIT.
// 
//  Description:
// 	This header file provides a wrapper around the PBS logging facilities.
//	Allowing applications that do not include the scheduling library to
//	take advantage of the logging facilities.
//  Author:  Walt Akers
// -----------------------------------------------------------------------------
#ifndef _PBS_LOG_H_
#define _PBS_LOG_H_

#include <stdio.h>
#include <string.h>
#include <stdarg.h>

const char * SetLogLocal  ( char * szAppName );
void         SetLogRemote (void);

void LogRecord    (const char * local, const char * formatString, ... );
void LogError     (const char * local, const char * formatString, ... );

#endif 
