#include <PBS_Server.h>
#include <PBS_Hash.h>

const char * msg_daemonname = SetLogLocal("testUnderlord");

int main ( int argc, char ** argv )
{
int connID;

if(argc<3)
	{
	fprintf(stderr, "Format is : dumpJobNodes server jobID\n");
	}
else if((connID = pbs_connect(argv[1]))<=0)
	{
	fprintf(stderr, "%s does not appear to be a valid server\n", argv[1]);
	}
else	{
	PBS_Server server(connID);
	char jobName[256];
	sprintf(jobName, "%s.%s", argv[2], argv[1]);
	
	PBS_Job * job = server.getJob(jobName);
	if(job==NULL)
		{
		fprintf(stderr, "Job %s does not exist on server %s\n", argv[2], argv[1]);
		}
	else	{
		const char ** execHost = job->getExecutionHosts();
		if(execHost && *execHost)
			{
			PBSStringHash hash;
			size_t        idx;
			char          buf[256];
			char        * ptr;
			
			for(idx=0; execHost[idx]!=NULL; idx++);

			char ** hostArray = new char * [idx+1];
			memset(hostArray, 0, idx*sizeof(char *));
			
			for(idx = 0; *execHost; execHost++)
				{
				strcpy(buf, *execHost);
				if((ptr = strchr(buf, '/'))!=NULL) *ptr = 0;
				if(hash.find(buf)==NULL)
					{
					hostArray[idx] = strdup(buf);
					hash.insert(hostArray[idx], (void *)1);
					idx++;
					}
				}
			for(idx=0; hostArray[idx]!=NULL; idx++)
				{
				fprintf(stdout, "%s\n", hostArray[idx]);
				free(hostArray[idx]);
				}
			delete[] hostArray;
			}
		}
			
	pbs_disconnect(server.getConnectionID());
	}
return 0;
}
