#include <UnderLord.h>
#include <ClusterNode.h>
#include <NodeSet.h>
#include <PBS_Log.h>

const char * msg_daemonname = SetLogLocal("testNodeSet");

int main (int argc, char ** argv)
{
int            connID = -1;
FILE         * fp  = NULL;
char           buf[1024];
char         * ptr;
NodeSetManager nodeSetMgr;

if((fp = fopen("/usr/spool/PBS/server_name", "r"))!=NULL &&
   (fgets(buf, 1024, fp)!=NULL))
	{
	// Remove the trailing carriage return
	if((ptr = strchr(buf, '\n'))!=NULL) *ptr = 0;

	connID = pbs_connect(buf);
	fclose(fp);
	}

if(connID<=0)
	{
	fprintf(stdout, "Error: Server name unspecified or not valid\n");
	return 0;
	}

PBS_KeywordTable keyTable;
PBS_Server       server;
server.loadData(connID);

PBS_NodeList & nodeList = (PBS_NodeList &)server;
size_t         nodeIdx  = 0;
size_t         maxIdx   = nodeList.getNodeCount();
PBS_Node    *  node     = NULL;
size_t         nNodes = 0; 
ClusterNode ** nodes = new ClusterNode * [ maxIdx ];

while((node=nodeList[nodeIdx])!=NULL && nNodes<maxIdx)
	{
	PBS_Node::NodeState state = node->getState();
	
	if(state!=PBS_Node::UNKNOWN_STATE &&
	   state!=PBS_Node::DOWN          &&
	   state!=PBS_Node::OFFLINE)
		{
		ClusterNode * cNode = new ClusterNode(*node, keyTable, nNodes);
		nodes[nNodes++] = cNode;
		}
	nodeIdx++;
	}


const char * askFor[] =
	{
	"Single",
	"Dual",
	"Myrinet",
	"NonMyrinet",
	"All",
	NULL
	};

for(int passIdx=0; passIdx<10; passIdx++)
	{
	nodeSetMgr.startCycle(nodes, nNodes);
	for(int askIdx=0; askFor[askIdx]!=NULL; askIdx++)
		{
		size_t nodeSetCnt;
		ClusterNode ** nodeList = nodeSetMgr.getNodes(askFor[askIdx], nodeSetCnt);
	
		if(passIdx==9)
			{
			fprintf(stdout, "\nAsked for %s and got...\n", askFor[askIdx]);
			for(int gotIdx=0; gotIdx<nodeSetCnt; gotIdx++)
				{
				fprintf(stdout, "\t%s\n", nodeList[gotIdx]->getName());
				}
			}
		}
	nodeSetMgr.endCycle();
	}
while(nNodes>0)
	{
	delete nodes[--nNodes];
	}

delete [] nodes;

pbs_disconnect(connID);
}
