#include <FreeProcMatrix.h>
#include <SimpleProcessor.h>
#include <SchedStatic.h>
#include <FreeTimeSet.h>
#include <PBS_Log.h>

const char * msg_daemonname = SetLogLocal("testProcessorSort");

int main ()
{
SimpleProcessor hpc1a_0("hpc1a", 0);
hpc1a_0.claim("Job 1", SchedStatic::getNow()-100000, 60);
hpc1a_0.claim("Job 2", SchedStatic::getNow(), 320);
hpc1a_0.claim("Job 3", SchedStatic::getNow()+462, 320);
hpc1a_0.claim("Job 4", SchedStatic::getNow()+903, 320);
hpc1a_0.claim("Job 5", SchedStatic::getNow()+1369, 320);
SimpleProcessor hpc1a_1("hpc1a", 1);
hpc1a_1.claim("Job 1", SchedStatic::getNow()-100000, 60);
hpc1a_1.claim("Job 2", SchedStatic::getNow(), 330);
hpc1a_1.claim("Job 3", SchedStatic::getNow()+462, 330);
hpc1a_1.claim("Job 4", SchedStatic::getNow()+903, 330);
hpc1a_1.claim("Job 5", SchedStatic::getNow()+1369, 330);
SimpleProcessor hpc1a_2("hpc1a", 2);
hpc1a_2.claim("Job 1", SchedStatic::getNow()-100000, 60);
hpc1a_2.claim("Job 2", SchedStatic::getNow(), 340);
hpc1a_2.claim("Job 3", SchedStatic::getNow()+462, 340);
hpc1a_2.claim("Job 4", SchedStatic::getNow()+903, 340);
hpc1a_2.claim("Job 5", SchedStatic::getNow()+1369, 340);
SimpleProcessor hpc1a_3("hpc1a", 3);
hpc1a_3.claim("Job 1", SchedStatic::getNow()-100000, 60);
hpc1a_3.claim("Job 2", SchedStatic::getNow(), 350);
hpc1a_3.claim("Job 3", SchedStatic::getNow()+462, 350);
hpc1a_3.claim("Job 4", SchedStatic::getNow()+903, 350);
hpc1a_3.claim("Job 5", SchedStatic::getNow()+1369, 350);
SimpleProcessor hpc1a_4("hpc1a", 4);
hpc1a_4.claim("Job 1", SchedStatic::getNow()-40000, 60);
hpc1a_4.claim("Job 2", SchedStatic::getNow(), 320);
hpc1a_4.claim("Job 3", SchedStatic::getNow()+465, 317);
hpc1a_4.claim("Job 4", SchedStatic::getNow()+906, 317);
hpc1a_4.claim("Job 5", SchedStatic::getNow()+1372, 317);
SimpleProcessor hpc1a_5("hpc1a", 5);
hpc1a_5.claim("Job 1", SchedStatic::getNow()-100000, 60);
hpc1a_5.claim("Job 2", SchedStatic::getNow(), 330);
hpc1a_5.claim("Job 3", SchedStatic::getNow()+465, 327);
hpc1a_5.claim("Job 4", SchedStatic::getNow()+906, 327);
hpc1a_5.claim("Job 5", SchedStatic::getNow()+1372, 327);
SimpleProcessor hpc1a_6("hpc1a", 6);
hpc1a_6.claim("Job 1", SchedStatic::getNow()-100000, 60);
hpc1a_6.claim("Job 2", SchedStatic::getNow(), 340);
hpc1a_6.claim("Job 3", SchedStatic::getNow()+465, 337);
hpc1a_6.claim("Job 4", SchedStatic::getNow()+906, 337);
hpc1a_6.claim("Job 5", SchedStatic::getNow()+1372, 337);
SimpleProcessor hpc1a_7("hpc1a", 7);
hpc1a_7.claim("Job 1", SchedStatic::getNow()-100000, 60);
hpc1a_7.claim("Job 2", SchedStatic::getNow(), 350);
hpc1a_7.claim("Job 3", SchedStatic::getNow()+465, 347);
hpc1a_7.claim("Job 4", SchedStatic::getNow()+906, 347);
hpc1a_7.claim("Job 5", SchedStatic::getNow()+772, 347);

hpc1a_3.asciiDump();

FreeProcMatrix master;
master.append(&hpc1a_0);
master.append(&hpc1a_1);
master.append(&hpc1a_2);
master.append(&hpc1a_3);
master.append(&hpc1a_4);
master.append(&hpc1a_5);
master.append(&hpc1a_6);
master.append(&hpc1a_7);
master.sort();
master.asciiDump();

for(int i=0; i<12; i++)
	{
	fprintf(stdout, "\n\nTaking free time in groups of %i processors\n", i);
	FreeTimeSet * slots = master.merge(i);
	FreeTimeSet * next = slots;
	while(next) {
		next->asciiDump();
		next = next->getNext();
		}
	while(slots)
		{
		next = slots->getNext();
		delete slots;
		slots = next;
		}
	}
}
