#include <UnderLord.h>
#include <DurationStage.h>
#include <JobAgeStage.h>
#include <UserShareStage.h>
#include <UserPriorityStage.h>
#include <QueuePriorityStage.h>
#include <PBS_Server.h>
#include <unistd.h>

const char * msg_daemonname = SetLogLocal("testUnderlord");

int main (int argc, char ** argv)
{
int    connID = -1;
FILE * fp  = NULL;
char   buf[1024];
char * ptr;

if((fp = fopen("/usr/spool/PBS/server_name", "r"))!=NULL &&
   (fgets(buf, 1024, fp)!=NULL))
	{
	// Remove the trailing carriage return
	if((ptr = strchr(buf, '\n'))!=NULL) *ptr = 0;

	connID = pbs_connect(buf);
	fclose(fp);
	}

if(connID<=0)
	{
	fprintf(stdout, "Error: Server name unspecified or not valid\n");
	return 0;
	}


PBS_Parameters & params = PBS_Parameters::attach();
PBS_AccountingDatabase serverDB (ptr); 
UnderLord underLord;

underLord.addStage(new DurationStage());
underLord.addStage(new JobAgeStage());
underLord.addStage(new UserPriorityStage());
underLord.addStage(new UserShareStage(serverDB));
underLord.addStage(new QueuePriorityStage(underLord.getServer(), serverDB));
serverDB.update(underLord.getServer());
underLord.processJobs(connID);

return 0;
}
